package com.example.demo.product.controller;

import com.example.demo.product.service.impl.*;
import com.example.demo.user.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/product")
public class ProductController {
    @Autowired
    private ProductServiceImpl productService;
    @Autowired
    private ProductFlightServiceImpl productFlightService;
    @Autowired
    private ProductHotelServiceImpl productHotelService;
    @Autowired
    private ProductTicketServiceImpl productTicketService;
    @Autowired
    private ProductTrainServiceImpl productTrainService;

    @RequestMapping("/syncDataToEs")
    public ResultVo syncDataToEs() {
        return productService.syncDataToEs();
    }

    @RequestMapping("/getProductList")
    public ResultVo getProductList(@RequestHeader("token") String token) {
        return productService.getProductList(token);
    }

    @RequestMapping("/flightSyncDataToEs")
    public ResultVo FlightSyncDataToEs(){
        return productFlightService.flightSyncDataToEs();
    }

    @RequestMapping("/getFlightList")
    public ResultVo getFlightList(@RequestHeader("token") String token) {
        return productFlightService.getFlightList(token);
    }

    @RequestMapping("/hotelSyncDataToEs")
    public ResultVo hotelSyncDataToEs(){
        return productHotelService.hotelSyncDataToEs();
    }

    @RequestMapping("/getHotelList")
    public ResultVo getHotelList(@RequestHeader("token") String token) {
        return productHotelService.getHotelList(token);
    }

    @RequestMapping("/ticketSyncDataToEs")
    public ResultVo ticketSyncDataToEs(){
        return productTicketService.ticketSyncDataToEs();
    }

    @RequestMapping("/getTicketList")
    public ResultVo getTicketList(@RequestHeader("token") String token) {
        return productTicketService.getTicketList(token);
    }

    @RequestMapping("/trainSyncDataToEs")
    public ResultVo trainSyncDataToEs(){
        return productTrainService.trainSyncDataToEs();
    }

    @RequestMapping("/getTrainList")
    public ResultVo getTrainList(@RequestHeader("token") String token) {
        return productTrainService.getTrainList(token);
    }
}
