package com.example.demo.product.domain;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.util.Date;
import lombok.Data;

/**
 * 机票产品扩展信息表
 * @TableName product_flight
 */
@TableName(value ="product_flight")
@Data
public class ProductFlight {
    /**
     * 机票产品ID
     */
    @TableId
    private Long id;

    /**
     * 关联产品主表ID
     */
    private Long productId;

    /**
     * 航班号
     */
    private String flightNo;

    /**
     * 出发机场
     */
    private String departureAirport;

    /**
     * 到达机场
     */
    private String arrivalAirport;

    /**
     * 出发时间
     */
    private Date departureTime;

    /**
     * 到达时间
     */
    private Date arrivalTime;

    /**
     * 座位类型（如“经济舱”“商务舱”）
     */
    private String seatType;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        ProductFlight other = (ProductFlight) that;
        return (this.getId() == null ? other.getId() == null : this.getId().equals(other.getId()))
            && (this.getProductId() == null ? other.getProductId() == null : this.getProductId().equals(other.getProductId()))
            && (this.getFlightNo() == null ? other.getFlightNo() == null : this.getFlightNo().equals(other.getFlightNo()))
            && (this.getDepartureAirport() == null ? other.getDepartureAirport() == null : this.getDepartureAirport().equals(other.getDepartureAirport()))
            && (this.getArrivalAirport() == null ? other.getArrivalAirport() == null : this.getArrivalAirport().equals(other.getArrivalAirport()))
            && (this.getDepartureTime() == null ? other.getDepartureTime() == null : this.getDepartureTime().equals(other.getDepartureTime()))
            && (this.getArrivalTime() == null ? other.getArrivalTime() == null : this.getArrivalTime().equals(other.getArrivalTime()))
            && (this.getSeatType() == null ? other.getSeatType() == null : this.getSeatType().equals(other.getSeatType()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getId() == null) ? 0 : getId().hashCode());
        result = prime * result + ((getProductId() == null) ? 0 : getProductId().hashCode());
        result = prime * result + ((getFlightNo() == null) ? 0 : getFlightNo().hashCode());
        result = prime * result + ((getDepartureAirport() == null) ? 0 : getDepartureAirport().hashCode());
        result = prime * result + ((getArrivalAirport() == null) ? 0 : getArrivalAirport().hashCode());
        result = prime * result + ((getDepartureTime() == null) ? 0 : getDepartureTime().hashCode());
        result = prime * result + ((getArrivalTime() == null) ? 0 : getArrivalTime().hashCode());
        result = prime * result + ((getSeatType() == null) ? 0 : getSeatType().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", productId=").append(productId);
        sb.append(", flightNo=").append(flightNo);
        sb.append(", departureAirport=").append(departureAirport);
        sb.append(", arrivalAirport=").append(arrivalAirport);
        sb.append(", departureTime=").append(departureTime);
        sb.append(", arrivalTime=").append(arrivalTime);
        sb.append(", seatType=").append(seatType);
        sb.append("]");
        return sb.toString();
    }
}