package com.example.demo.product.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.util.Date;
import lombok.Data;

/**
 * 门票产品扩展信息表
 * @TableName product_ticket
 */
@TableName(value ="product_ticket")
@Data
public class ProductTicket {
    /**
     * 门票产品ID
     */
    @TableId
    private Long id;

    /**
     * 关联产品主表ID
     */
    private Long productId;

    /**
     * 景区名称
     */
    private String scenicName;

    /**
     * 门票类型（如“成人票”“儿童票”）
     */
    private String ticketType;

    /**
     * 景区地址
     */
    private String address;

    /**
     * 有效期开始日期
     */
    private Date validStartDate;

    /**
     * 有效期结束日期
     */
    private Date validEndDate;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        ProductTicket other = (ProductTicket) that;
        return (this.getId() == null ? other.getId() == null : this.getId().equals(other.getId()))
            && (this.getProductId() == null ? other.getProductId() == null : this.getProductId().equals(other.getProductId()))
            && (this.getScenicName() == null ? other.getScenicName() == null : this.getScenicName().equals(other.getScenicName()))
            && (this.getTicketType() == null ? other.getTicketType() == null : this.getTicketType().equals(other.getTicketType()))
            && (this.getAddress() == null ? other.getAddress() == null : this.getAddress().equals(other.getAddress()))
            && (this.getValidStartDate() == null ? other.getValidStartDate() == null : this.getValidStartDate().equals(other.getValidStartDate()))
            && (this.getValidEndDate() == null ? other.getValidEndDate() == null : this.getValidEndDate().equals(other.getValidEndDate()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getId() == null) ? 0 : getId().hashCode());
        result = prime * result + ((getProductId() == null) ? 0 : getProductId().hashCode());
        result = prime * result + ((getScenicName() == null) ? 0 : getScenicName().hashCode());
        result = prime * result + ((getTicketType() == null) ? 0 : getTicketType().hashCode());
        result = prime * result + ((getAddress() == null) ? 0 : getAddress().hashCode());
        result = prime * result + ((getValidStartDate() == null) ? 0 : getValidStartDate().hashCode());
        result = prime * result + ((getValidEndDate() == null) ? 0 : getValidEndDate().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", productId=").append(productId);
        sb.append(", scenicName=").append(scenicName);
        sb.append(", ticketType=").append(ticketType);
        sb.append(", address=").append(address);
        sb.append(", validStartDate=").append(validStartDate);
        sb.append(", validEndDate=").append(validEndDate);
        sb.append("]");
        return sb.toString();
    }
}