package com.example.demo.product.entity;

import cn.easyes.annotation.HighLight;
import cn.easyes.annotation.IndexField;
import cn.easyes.annotation.IndexId;
import cn.easyes.annotation.IndexName;
import cn.easyes.annotation.rely.Analyzer;
import cn.easyes.annotation.rely.FieldType;
import cn.easyes.annotation.rely.IdType;
import lombok.Data;

import java.util.Date;

/**
 * 机票产品扩展信息表
 *  product_flight
 */
@IndexName(value ="flight",shardsNum = 3, replicasNum = 2)
@Data
public class ProductFlightEntity {
    /**
     * 机票产品ID
     */
    @IndexId(type = IdType.CUSTOMIZE)
    private Long id;

    /**
     * 关联产品主表ID
     */
    @IndexField(fieldType = FieldType.LONG)
    private Long productId;

    /**
     * 航班号
     */
    @IndexField(fieldType = FieldType.KEYWORD)
    private String flightNo;

    /**
     * 出发机场
     */
    @HighLight(mappingField = "highlightContent")
    @IndexField(fieldType = FieldType.TEXT,analyzer = Analyzer.IK_MAX_WORD,searchAnalyzer = Analyzer.IK_SMART)
    private String departureAirport;

    /**
     * 到达机场
     */
    @HighLight(mappingField = "highlightContent")
    @IndexField(fieldType = FieldType.TEXT,analyzer = Analyzer.IK_MAX_WORD,searchAnalyzer = Analyzer.IK_SMART)
    private String arrivalAirport;

    /**
     * 出发时间
     */
    @IndexField(fieldType = FieldType.DATE)
    private Date departureTime;

    /**
     * 到达时间
     */
    @IndexField(fieldType = FieldType.DATE)
    private Date arrivalTime;

    /**
     * 座位类型（如“经济舱”“商务舱”）
     */
    @IndexField(fieldType = FieldType.KEYWORD)
    private String seatType;
}