package com.example.demo.product.entity;

import cn.easyes.annotation.HighLight;
import cn.easyes.annotation.IndexField;
import cn.easyes.annotation.IndexId;
import cn.easyes.annotation.IndexName;
import cn.easyes.annotation.rely.Analyzer;
import cn.easyes.annotation.rely.FieldType;
import cn.easyes.annotation.rely.IdType;
import lombok.Data;

import java.util.Date;

/**
 * 门票产品扩展信息表
 *  product_ticket
 */
@IndexName(value ="ticket",shardsNum = 3,replicasNum = 2)
@Data
public class ProductTicketEntity {
    /**
     * 门票产品ID
     */
    @IndexId(type = IdType.CUSTOMIZE)
    private Long id;

    /**
     * 关联产品主表ID
     */
    @IndexField(fieldType = FieldType.LONG)
    private Long productId;

    /**
     * 景区名称
     */
    @HighLight(mappingField = "highlightContent")
    @IndexField(fieldType = FieldType.TEXT,analyzer = Analyzer.IK_MAX_WORD,searchAnalyzer = Analyzer.IK_SMART)
    private String scenicName;

    /**
     * 门票类型（如“成人票”“儿童票”）
     */
    @IndexField(fieldType = FieldType.KEYWORD)
    private String ticketType;

    /**
     * 景区地址
     */
    @IndexField(fieldType = FieldType.TEXT,analyzer = Analyzer.IK_MAX_WORD,searchAnalyzer = Analyzer.IK_SMART)
    private String address;

    /**
     * 有效期开始日期
     */
    @IndexField(fieldType = FieldType.DATE)
    private Date validStartDate;

    /**
     * 有效期结束日期
     */
    @IndexField(fieldType = FieldType.DATE)
    private Date validEndDate;
}