package com.example.demo.product.service.impl;

import cn.easyes.core.biz.EsPageInfo;
import cn.easyes.core.conditions.LambdaEsQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.demo.common.utils.TokenUtils;
import com.example.demo.product.domain.ProductFlight;
import com.example.demo.product.entity.ProductFlightEntity;
import com.example.demo.product.esmapper.ProductFlightEsMapper;
import com.example.demo.product.service.ProductFlightService;
import com.example.demo.product.dao.ProductFlightMapper;
import com.example.demo.user.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
* @author 徐乐
* @description 针对表【product_flight(机票产品扩展信息表)】的数据库操作Service实现
* @createDate 2025-06-10 20:12:01
*/
@Service
public class ProductFlightServiceImpl extends ServiceImpl<ProductFlightMapper, ProductFlight>
    implements ProductFlightService{
    @Autowired
    private ProductFlightEsMapper productFlightEsMapper;

    @Override
    public ResultVo flightSyncDataToEs() {
        //创建索引
        productFlightEsMapper.createIndex();
        List<ProductFlight> flightList = this.list();
        List<ProductFlightEntity> productFlightEntityList = new ArrayList<>();
        for (ProductFlight productFlight : flightList) {
            ProductFlightEntity productFlightEntity = new ProductFlightEntity();
            productFlightEntity.setId(productFlight.getId());
            productFlightEntity.setProductId(productFlight.getProductId());
            productFlightEntity.setFlightNo(productFlight.getFlightNo());
            productFlightEntity.setDepartureAirport(productFlight.getDepartureAirport());
            productFlightEntity.setArrivalAirport(productFlight.getArrivalAirport());
            productFlightEntity.setDepartureTime(productFlight.getDepartureTime());
            productFlightEntity.setArrivalTime(productFlight.getArrivalTime());
            productFlightEntity.setSeatType(productFlight.getSeatType());
            productFlightEntityList.add(productFlightEntity);
        }
        productFlightEsMapper.insertBatch(productFlightEntityList);
        return ResultVo.success("同步数据成功");
    }

    @Override
    public ResultVo getFlightList(String token) {
        Long userId = TokenUtils.getUserId(token);
        if (userId==null){
            return ResultVo.error(101,"请先登录");
        }
        LambdaEsQueryWrapper<ProductFlightEntity> wrapper = new LambdaEsQueryWrapper();
        EsPageInfo<ProductFlightEntity> pageInfo = productFlightEsMapper.pageQuery(wrapper,1,20);
        return ResultVo.success(pageInfo);
    }
}




