package com.example.demo.product.service.impl;

import cn.easyes.core.biz.EsPageInfo;
import cn.easyes.core.conditions.LambdaEsQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.demo.common.utils.TokenUtils;
import com.example.demo.product.domain.ProductTicket;
import com.example.demo.product.entity.ProductTicketEntity;
import com.example.demo.product.esmapper.ProductTicketEsMapper;
import com.example.demo.product.service.ProductTicketService;
import com.example.demo.product.dao.ProductTicketMapper;
import com.example.demo.user.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
* @author 徐乐
* @description 针对表【product_ticket(门票产品扩展信息表)】的数据库操作Service实现
* @createDate 2025-06-16 20:08:46
*/
@Service
public class ProductTicketServiceImpl extends ServiceImpl<ProductTicketMapper, ProductTicket>
    implements ProductTicketService{
    @Autowired
    private ProductTicketEsMapper productTicketEsMapper;

    @Override
    public ResultVo ticketSyncDataToEs() {
        //创建索引
        productTicketEsMapper.createIndex();
        List<ProductTicket> ticketList = this.list();
        List<ProductTicketEntity> productTicketEntityList = new ArrayList<>();
        for (ProductTicket productTicket : ticketList) {
            ProductTicketEntity productTicketEntity = new ProductTicketEntity();
            productTicketEntity.setId(productTicket.getId());
            productTicketEntity.setProductId(productTicket.getProductId());
            productTicketEntity.setScenicName(productTicket.getScenicName());
            productTicketEntity.setTicketType(productTicket.getTicketType());
            productTicketEntity.setAddress(productTicket.getAddress());
            productTicketEntity.setValidStartDate(productTicket.getValidStartDate());
            productTicketEntity.setValidEndDate(productTicket.getValidEndDate());
            productTicketEntityList.add(productTicketEntity);
        }
        productTicketEsMapper.insertBatch(productTicketEntityList);
        return ResultVo.success("数据同步成功");
    }

    @Override
    public ResultVo getTicketList(String token) {
        Long userId = TokenUtils.getUserId(token);
        if (userId==null){
            return ResultVo.error(101,"请先登录");
        }
        LambdaEsQueryWrapper<ProductTicketEntity> wrapper = new LambdaEsQueryWrapper<>();
        EsPageInfo<ProductTicketEntity> pageInfo = productTicketEsMapper.pageQuery(wrapper, 1, 20);
        return ResultVo.success(pageInfo);
    }
}