package com.example.demo.product.service.impl;

import cn.easyes.core.biz.EsPageInfo;
import cn.easyes.core.conditions.LambdaEsQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.demo.common.utils.TokenUtils;
import com.example.demo.product.domain.ProductTrain;
import com.example.demo.product.entity.ProductTrainEntity;
import com.example.demo.product.esmapper.ProductTrainEsMapper;
import com.example.demo.product.service.ProductTrainService;
import com.example.demo.product.dao.ProductTrainMapper;
import com.example.demo.user.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
* @author 徐乐
* @description 针对表【product_train(车票产品扩展信息表)】的数据库操作Service实现
* @createDate 2025-06-10 20:12:01
*/
@Service
public class ProductTrainServiceImpl extends ServiceImpl<ProductTrainMapper, ProductTrain>
    implements ProductTrainService{
    @Autowired
    private ProductTrainEsMapper productTrainEsMapper;

    @Override
    public ResultVo trainSyncDataToEs() {
        //创建索引
        productTrainEsMapper.createIndex();
        List<ProductTrain> trainList = this.list();
        List<ProductTrainEntity> productTrainEntityList = new ArrayList<>();
        for (ProductTrain productTrain : trainList) {
            ProductTrainEntity productTrainEntity = new ProductTrainEntity();
            productTrainEntity.setId(productTrain.getId());
            productTrainEntity.setProductId(productTrain.getProductId());
            productTrainEntity.setTrainNo(productTrain.getTrainNo());
            productTrainEntity.setDepartureStation(productTrain.getDepartureStation());
            productTrainEntity.setArrivalStation(productTrain.getArrivalStation());
            productTrainEntity.setDepartureTime(productTrain.getDepartureTime());
            productTrainEntity.setArrivalTime(productTrain.getArrivalTime());
            productTrainEntityList.add(productTrainEntity);
        }
        productTrainEsMapper.insertBatch(productTrainEntityList);
        return ResultVo.success("同步数据成功");
    }

    @Override
    public ResultVo getTrainList(String token) {
        Long userId = TokenUtils.getUserId(token);
        if (userId==null){
            return ResultVo.error(101,"请先登录");
        }
        LambdaEsQueryWrapper<ProductTrainEntity> wrapper = new LambdaEsQueryWrapper<>();
        EsPageInfo<ProductTrainEntity> pageInfo = productTrainEsMapper.pageQuery(wrapper, 1, 20);
        return ResultVo.success(pageInfo);
    }
}




