package com.example.demo.scenic_spot.service.impl;

import cn.easyes.core.biz.EsPageInfo;
import cn.easyes.core.conditions.LambdaEsQueryWrapper;
import cn.hutool.core.util.IdUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.demo.common.utils.TokenUtils;
import com.example.demo.scenic_spot.domain.ScenicSpot;
import com.example.demo.scenic_spot.entity.ScenicSpotEntity;
import com.example.demo.scenic_spot.esmapper.ScenicSpotEsMapper;
import com.example.demo.scenic_spot.service.ScenicSpotService;
import com.example.demo.scenic_spot.dao.ScenicSpotMapper;
import com.example.demo.user.vo.ResultVo;
import org.elasticsearch.client.indices.GetIndexResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
* @author 徐乐
* @description 针对表【scenic_spot(景点信息表)】的数据库操作Service实现
* @createDate 2025-06-17 14:17:18
*/
@Service
public class ScenicSpotServiceImpl extends ServiceImpl<ScenicSpotMapper, ScenicSpot>
    implements ScenicSpotService{

    @Autowired
    private ScenicSpotEsMapper scenicSpotEsMapper;
    @Override
    public ResultVo syncDataToEs() {
        //创建索引
        scenicSpotEsMapper.createIndex();
        List<ScenicSpot> scenicSpotList = this.list();
        List<ScenicSpotEntity> scenicSpotEntityList = new ArrayList<>();
        for (ScenicSpot scenicSpot : scenicSpotList) {
            ScenicSpotEntity scenicSpotEntity = new ScenicSpotEntity();
            scenicSpotEntity.setId(scenicSpot.getId());
            scenicSpotEntity.setName(scenicSpot.getName());
            scenicSpotEntity.setPinyin(scenicSpot.getPinyin());
            scenicSpotEntity.setDescription(scenicSpot.getDescription());
            scenicSpotEntity.setAddress(scenicSpot.getAddress());
            scenicSpotEntity.setCity(scenicSpot.getCity());
            scenicSpotEntity.setDistrict(scenicSpot.getDistrict());
            scenicSpotEntity.setLongitudeStr(scenicSpot.getLongitudeStr());
            scenicSpotEntity.setLatitudeStr(scenicSpot.getLatitudeStr());
            scenicSpotEntity.setCategory(scenicSpot.getCategory());
            scenicSpotEntity.setLevel(scenicSpot.getLevel());
            scenicSpotEntity.setCoverImage(scenicSpot.getCoverImage());
            scenicSpotEntity.setTicketPrice(scenicSpot.getTicketPrice());
            scenicSpotEntity.setDiscountPrice(scenicSpot.getDiscountPrice());
            scenicSpotEntity.setOpenTime(scenicSpot.getOpenTime());
            scenicSpotEntity.setOpenTimeStart(scenicSpot.getOpenTimeStart());
            scenicSpotEntity.setOpenTimeEnd(scenicSpot.getOpenTimeEnd());
            scenicSpotEntity.setRecommendedTime(scenicSpot.getRecommendedTime());
            scenicSpotEntity.setContactPhone(scenicSpot.getContactPhone());
            scenicSpotEntity.setWebsite(scenicSpot.getWebsite());
            scenicSpotEntity.setIsHot(scenicSpot.getIsHot());
            scenicSpotEntity.setIsRecommended(scenicSpot.getIsRecommended());
            scenicSpotEntity.setStatus(scenicSpot.getStatus());
            scenicSpotEntity.setTags(scenicSpot.getTags());
            scenicSpotEntity.setCreatedBy(scenicSpot.getCreatedBy());
            scenicSpotEntity.setCreatedTime(scenicSpot.getCreatedTime());
            scenicSpotEntity.setUpdatedBy(scenicSpot.getUpdatedBy());
            scenicSpotEntity.setUpdatedTime(scenicSpot.getUpdatedTime());
            scenicSpotEntity.setIsDeleted(scenicSpot.getIsDeleted());
            scenicSpotEntityList.add(scenicSpotEntity);
        }
        scenicSpotEsMapper.insertBatch(scenicSpotEntityList, "scenic_spot");
        return ResultVo.success("数据同步成功");
    }

    @Override
    public ResultVo getScenicSpotList(String token) {
        Long userId = TokenUtils.getUserId(token);
        if (userId==null){
            return ResultVo.error(101,"请先登录");
        }
        LambdaEsQueryWrapper<ScenicSpotEntity> wrapper = new LambdaEsQueryWrapper<>();
        EsPageInfo<ScenicSpotEntity> pageInfo = scenicSpotEsMapper.pageQuery(wrapper, 1, 20);
        return ResultVo.success(pageInfo);
    }
}




